require "defines"

function init()
	if not global.deadPlayers then
		global.deadPlayers = {}
		end
	game.always_day = true
	load_market()
	create_forces()
	chart_map()

end

script.on_init(init)
--script.on_load(init)


script.on_event(defines.events.on_player_created, function(event)
	local player = game.get_player(event.player_index)
	local force = player.force
			
		if force == game.forces.player then
		player.gui.top.add{type = "button", caption = "Blue Team" .. " " ..global.bluemembers, name = "blue"}.style.font_color = {b = 1, r= 0.6, g = 0.6}
		player.gui.top.add{type = "button", caption = "Red Team" .. " " ..global.redmembers, name = "red"}.style.font_color = {b = 0.3, r= 1, g = 0.3}
			end
		refresh_score()
			
			end)
   
	
function create_forces()
if game.forces.blue ==nil then
	game.create_force("blue")	
	global.bluemembers = 0
	game.forces.blue.logistic_robot_speed_modifier = 3	
	game.forces.blue.technologies["automated-construction"].researched = true
	game.create_force("red")
	global.redmembers = 0
	game.forces.red.logistic_robot_speed_modifier = 3	
	game.forces.red.technologies["automated-construction"].researched = true
end
	end
	
function give_income()
				for i, player in pairs(game.players) do
					 player.insert({name = "coin" , count = 100})						
				end
end

function load_market()

if global.market_loaded == nil
	then
		local bluemarket = game.get_entity_by_tag("bluemarket")
		local redmarket = game.get_entity_by_tag("redmarket")
		
		
						bluemarket.add_market_item{price={{"coin", 400}}, offer={type="give-item", item="steel-axe"}}	 
						bluemarket.add_market_item{price={{"coin", 80}}, offer={type="give-item", item="repair-pack"}}
						bluemarket.add_market_item{price={{"coin", 160}}, offer={type="give-item", item="steel-chest"}}
				
						bluemarket.add_market_item{price={{"coin", 120}}, offer={type="give-item", item="piercing-bullet-magazine"}}	 
						bluemarket.add_market_item{price={{"coin", 300}}, offer={type="give-item", item="rocket"}}	 
						bluemarket.add_market_item{price={{"coin", 140}}, offer={type="give-item", item="piercing-shotgun-shell"}}	 
						bluemarket.add_market_item{price={{"coin", 220}}, offer={type="give-item", item="flame-thrower-ammo"}}	
						bluemarket.add_market_item{price={{"coin", 800}}, offer={type="give-item", item="land-mine"}}	 	
						bluemarket.add_market_item{price={{"coin", 1400}}, offer={type="give-item", item="car"}}	 	

			
						bluemarket.add_market_item{price={{"coin", 25}}, offer={type="give-item", item="medium-electric-pole"}}
						bluemarket.add_market_item{price={{"coin", 35}}, offer={type="give-item", item="big-electric-pole"}}

						bluemarket.add_market_item{price={{"coin", 8}}, offer={type="give-item", item="fast-transport-belt"}}	 		
						bluemarket.add_market_item{price={{"coin", 25}}, offer={type="give-item", item="fast-splitter"}}	 	
						bluemarket.add_market_item{price={{"coin", 40}}, offer={type="give-item", item="fast-transport-belt-to-ground"}}	
						
						bluemarket.add_market_item{price={{"coin", 35}}, offer={type="give-item", item="burner-mining-drill"}}	
						bluemarket.add_market_item{price={{"coin", 80}}, offer={type="give-item", item="basic-mining-drill"}}		
						
						bluemarket.add_market_item{price={{"coin", 5}}, offer={type="give-item", item="burner-inserter"}}	 
						bluemarket.add_market_item{price={{"coin", 12}}, offer={type="give-item", item="long-handed-inserter"}}	 	
						bluemarket.add_market_item{price={{"coin", 15}}, offer={type="give-item", item="fast-inserter"}}					
						
 	
						bluemarket.add_market_item{price={{"coin", 120}}, offer={type="give-item", item="steel-furnace"}}	
						bluemarket.add_market_item{price={{"coin", 180}}, offer={type="give-item", item="electric-furnace"}}
						bluemarket.add_market_item{price={{"coin", 75}}, offer={type="give-item", item="assembling-machine-1"}}
						bluemarket.add_market_item{price={{"coin", 115}}, offer={type="give-item", item="assembling-machine-2"}}
						
						bluemarket.add_market_item{price={{"coin", 20}}, offer={type="give-item", item="boiler"}}	 	
						bluemarket.add_market_item{price={{"coin", 70}}, offer={type="give-item", item="steam-engine"}}	 	
						bluemarket.add_market_item{price={{"coin", 120}}, offer={type="give-item", item="offshore-pump"}}
						
						bluemarket.add_market_item{price={{"coin", 15}}, offer={type="give-item", item="pipe"}}	
						bluemarket.add_market_item{price={{"coin", 35}}, offer={type="give-item", item="pipe-to-ground"}}	

						bluemarket.add_market_item{price={{"coin", 40}}, offer={type="give-item", item="solid-fuel"}}	 	 	 						
						bluemarket.add_market_item{price={{"coin", 25}}, offer={type="give-item", item="raw-fish"}}	 
						
						bluemarket.add_market_item{price={{"coin", 8000}}, offer={type="give-item", item="roboport"}}	 
						bluemarket.add_market_item{price={{"coin", 680}}, offer={type="give-item", item="logistic-robot"}}	 
						bluemarket.add_market_item{price={{"coin", 570}}, offer={type="give-item", item="construction-robot"}}	 
						bluemarket.add_market_item{price={{"coin", 250}}, offer={type="give-item", item="logistic-chest-storage"}}
						bluemarket.add_market_item{price={{"coin", 25}}, offer={type="give-item", item="blueprint"}}						
						
						
			
			
			
						redmarket.add_market_item{price={{"coin", 400}}, offer={type="give-item", item="steel-axe"}}	 
						redmarket.add_market_item{price={{"coin", 80}}, offer={type="give-item", item="repair-pack"}}
						redmarket.add_market_item{price={{"coin", 160}}, offer={type="give-item", item="steel-chest"}}
				
			
						redmarket.add_market_item{price={{"coin", 120}}, offer={type="give-item", item="piercing-bullet-magazine"}}	 
						redmarket.add_market_item{price={{"coin", 300}}, offer={type="give-item", item="rocket"}}	 
						redmarket.add_market_item{price={{"coin", 140}}, offer={type="give-item", item="piercing-shotgun-shell"}}	 
						redmarket.add_market_item{price={{"coin", 220}}, offer={type="give-item", item="flame-thrower-ammo"}}	
						redmarket.add_market_item{price={{"coin", 800}}, offer={type="give-item", item="land-mine"}}	 	
						redmarket.add_market_item{price={{"coin", 1400}}, offer={type="give-item", item="car"}}	 	

			
						redmarket.add_market_item{price={{"coin", 25}}, offer={type="give-item", item="medium-electric-pole"}}
						redmarket.add_market_item{price={{"coin", 35}}, offer={type="give-item", item="big-electric-pole"}}

						redmarket.add_market_item{price={{"coin", 8}}, offer={type="give-item", item="fast-transport-belt"}}	 		
						redmarket.add_market_item{price={{"coin", 25}}, offer={type="give-item", item="fast-splitter"}}	 	
						redmarket.add_market_item{price={{"coin", 40}}, offer={type="give-item", item="fast-transport-belt-to-ground"}}	
						
						redmarket.add_market_item{price={{"coin", 35}}, offer={type="give-item", item="burner-mining-drill"}}	
						redmarket.add_market_item{price={{"coin", 80}}, offer={type="give-item", item="basic-mining-drill"}}		
						
						redmarket.add_market_item{price={{"coin", 5}}, offer={type="give-item", item="burner-inserter"}}	 
						redmarket.add_market_item{price={{"coin", 12}}, offer={type="give-item", item="long-handed-inserter"}}	 	
						redmarket.add_market_item{price={{"coin", 15}}, offer={type="give-item", item="fast-inserter"}}					
						
 	
						redmarket.add_market_item{price={{"coin", 120}}, offer={type="give-item", item="steel-furnace"}}	
						redmarket.add_market_item{price={{"coin", 180}}, offer={type="give-item", item="electric-furnace"}}
						redmarket.add_market_item{price={{"coin", 75}}, offer={type="give-item", item="assembling-machine-1"}}
						redmarket.add_market_item{price={{"coin", 115}}, offer={type="give-item", item="assembling-machine-2"}}
						
						redmarket.add_market_item{price={{"coin", 20}}, offer={type="give-item", item="boiler"}}	 	
						redmarket.add_market_item{price={{"coin", 70}}, offer={type="give-item", item="steam-engine"}}	 	
						redmarket.add_market_item{price={{"coin", 120}}, offer={type="give-item", item="offshore-pump"}}
						
						redmarket.add_market_item{price={{"coin", 15}}, offer={type="give-item", item="pipe"}}	
						redmarket.add_market_item{price={{"coin", 35}}, offer={type="give-item", item="pipe-to-ground"}}	

						redmarket.add_market_item{price={{"coin", 40}}, offer={type="give-item", item="solid-fuel"}}	 	 	 						
						redmarket.add_market_item{price={{"coin", 25}}, offer={type="give-item", item="raw-fish"}}	  
						
						redmarket.add_market_item{price={{"coin", 8000}}, offer={type="give-item", item="roboport"}}	 
						redmarket.add_market_item{price={{"coin", 680}}, offer={type="give-item", item="logistic-robot"}}	 
						redmarket.add_market_item{price={{"coin", 570}}, offer={type="give-item", item="construction-robot"}}	 
						redmarket.add_market_item{price={{"coin", 250}}, offer={type="give-item", item="logistic-chest-storage"}}	
						redmarket.add_market_item{price={{"coin", 25}}, offer={type="give-item", item="blueprint"}}					 

			
			end
			global.market_loaded = 1
		end
		
 script.on_event(defines.events.on_gui_click, function(event)
 
 local player = game.players[event.player_index]
    if player.gui.top.blue ~= nil then
   if (event.element.name == "blue") then
		
     player.print("You have Joined Blue Team")
	 player.force = game.forces.blue
	 player.gui.top.red.destroy()	 
	 player.gui.top.blue.destroy()
	 player.color = {b = 1, r = 0.3, g = 0.3}
	 player.teleport({-240,0})
	 
				  player.insert{name="steel-axe", count=3}
				  
				  player.insert{name="submachine-gun", count=1}
				  player.insert{name="piercing-bullet-magazine", count=50}  
				  player.insert{name="combat-shotgun", count=1}
				  player.insert{name="piercing-shotgun-shell", count=50}  
				  player.insert{name="rocket-launcher", count=1}  
				  player.insert{name="rocket", count=50}
				  
				  player.insert{name="power-armor", count = 1}
				  player.insert{name="fusion-reactor-equipment", count = 1}
				  player.insert{name="energy-shield-mk2-equipment", count = 2}
				  player.insert{name="personal-roboport-equipment", count = 1}
				  player.insert{name="basic-exoskeleton-equipment", count = 1}
				  player.insert{name="construction-robot", count = 10}
				  player.insert{name="blueprint", count = 2}
				  player.insert{name="deconstruction-planner", count = 1}
				  
				  player.insert{name="coin", count = 10000}
	 global.bluemembers = global.bluemembers + 1
	 
   end
   end
   
   
   if player.gui.top.red ~= nil then
   if (event.element.name == "red") then
		local player = game.players[event.player_index]
   
     player.print("You have Joined Red Team")
	 player.force = game.forces.red
	 player.gui.top.red.destroy()	 
	 player.gui.top.blue.destroy()
	 player.color = {b = 0.3, r = 1, g = 0.3}
	 player.teleport({240,0})
	 
				  player.insert{name="steel-axe", count=3}
				  
				  player.insert{name="submachine-gun", count=1}
				  player.insert{name="piercing-bullet-magazine", count=50}  
				  player.insert{name="combat-shotgun", count=1}
				  player.insert{name="piercing-shotgun-shell", count=50}  
				  player.insert{name="rocket-launcher", count=1}  
				  player.insert{name="rocket", count=50}
				  
				  player.insert{name="power-armor", count = 1}
				  player.insert{name="fusion-reactor-equipment", count = 1}
				  player.insert{name="energy-shield-mk2-equipment", count = 2}
				  player.insert{name="personal-roboport-equipment", count = 1}
				  player.insert{name="basic-exoskeleton-equipment", count = 1}
				  player.insert{name="construction-robot", count = 10}
				  player.insert{name="blueprint", count = 2}
				  player.insert{name="deconstruction-planner", count = 1}
				  
				  player.insert{name="coin", count = 10000}
	 global.redmembers = global.redmembers + 1
	 
		
		
   end
   end
   
 end)
 
 script.on_event(defines.events.on_tick, function(event)

		for playerIndex, value in pairs(global.deadPlayers) do
	local player = game.players[playerIndex]
   		if player.character then
		
		
			if player.force == game.forces.red then
   				player.teleport({240,0})
					 
				  player.insert{name="steel-axe", count=3}
				  
				  player.insert{name="submachine-gun", count=1}
				  player.insert{name="piercing-bullet-magazine", count=50}  
				  player.insert{name="combat-shotgun", count=1}
				  player.insert{name="piercing-shotgun-shell", count=50}  
				  player.insert{name="rocket-launcher", count=1}  
				  player.insert{name="rocket", count=50}
				  
				  player.insert{name="power-armor", count = 1}
				  player.insert{name="fusion-reactor-equipment", count = 1}
				  player.insert{name="energy-shield-mk2-equipment", count = 2}
				  player.insert{name="personal-roboport-equipment", count = 1}
				  player.insert{name="basic-exoskeleton-equipment", count = 1}
				  player.insert{name="construction-robot", count = 10}
				  player.insert{name="blueprint", count = 2}
				  player.insert{name="deconstruction-planner", count = 1}
				  
				  player.insert{name="coin", count = 10000}

					
					end

			if player.force == game.forces.blue then
   				player.teleport({-240,0})
					 
				  player.insert{name="steel-axe", count=3}
				  
				  player.insert{name="submachine-gun", count=1}
				  player.insert{name="piercing-bullet-magazine", count=50}  
				  player.insert{name="combat-shotgun", count=1}
				  player.insert{name="piercing-shotgun-shell", count=50}  
				  player.insert{name="rocket-launcher", count=1}  
				  player.insert{name="rocket", count=50}
				  
				  player.insert{name="power-armor", count = 1}
				  player.insert{name="fusion-reactor-equipment", count = 1}
				  player.insert{name="energy-shield-mk2-equipment", count = 2}
				  player.insert{name="personal-roboport-equipment", count = 1}
				  player.insert{name="basic-exoskeleton-equipment", count = 1}
				  player.insert{name="construction-robot", count = 10}
				  player.insert{name="blueprint", count = 2}
				  player.insert{name="deconstruction-planner", count = 1}
				  
				  player.insert{name="coin", count = 10000}
					
					end
					

			

   			global.deadPlayers[playerIndex] = nil
   		end
		end
		if (game.tick % 900) == 0 then
			give_income()
		end

		end)
		




script.on_event(defines.events.on_entity_died, function(event)
	if event.entity.type == "player" then
  		
			for index, player in ipairs(game.players) do
			if not player.character and not global.deadPlayers[index] then
			global.deadPlayers[index] = true
	
			end
			
     
      end
	
end
end)

function chart_map()
	game.forces.blue.chart(game.surfaces.nauvis,{{-200, -300}, {200, 300}})
	game.forces.red.chart(game.surfaces.nauvis,{{-200, -300}, {200, 300}})
	end
	

script.on_event(defines.events.on_rocket_launched, function(event)
  local force = event.rocket.force
  if event.rocket.get_item_count("satellite") > 0 then
    if global.satellite_sent == nil then
      global.satellite_sent = {}
    end
	if force == game.forces.blue then
	global.bluescore = global.bluescore +1
	end
	if force == game.forces.red then
	global.redscore = global.redscore + 1
	end
	refresh_score()
    
  else
    if (#game.players <= 1) then
      game.show_message_dialog{text = {"gui-rocket-silo.rocket-launched-without-satellite"}}
    else
      for index, player in pairs(force.players) do
        player.print({"gui-rocket-silo.rocket-launched-without-satellite"})
      end
    end
  end
end)



function refresh_score()
	local Blue = {b=1, g=0.3, r = 0.3}
	local Red = {r=1, g = 0.3, b = 0.3}
		if global.bluescore == nil then
			global.bluescore = 0
		end
		if global.redscore == nil then
			global.redscore = 0
		end
   	for i, player in ipairs(game.players) do

		if player.gui.left.rocket_score == nil then

	local frame = player.gui.left.add{name = "rocket_score", type = "frame", direction = "horizontal", caption="Rocket score"}
	frame.add{type="label", name="blue_score", caption= global.redscore, style="caption_label_style"}.style.font_color = Blue
	frame.add{type="label", name="Vs", caption= "VS", style="caption_label_style"}
	frame.add{type="label", name="red_score", caption= global.bluescore, style="caption_label_style"}.style.font_color = Red

	else
		player.gui.left.rocket_score.blue_score.caption = tostring(global.bluescore)
		player.gui.left.rocket_score.red_score.caption = tostring(global.redscore)
	
end
end
end

		
		
		
		
